/**
 * Created by IntelliJ IDEA.
 * User: JoonHo Son
 * Date: 12. 3. 2
 * Time: 오후 4:07
 */

var downloadSearchType;
var downloadSearchKeyword;

/**
 * 단말 정보를 조회한다.
 */
function fn_callback() {
	var phoneType, agencyCode, productName, parameter;
	var CURITELYN = "N";
	if (arguments.length < 3) {
		phoneType = jQuery("input[name='phonetype']:checked").val();
		agencyCode = jQuery("input[name='agency_code']:checked").val();
		productName = jQuery("#mdl_nm option:selected").val();
	} else {
		phoneType = arguments[0];
		agencyCode = arguments[1];
		productName = arguments[2];

		jQuery("input[name='phonetype']").each(function () {
			if (jQuery(this).val() == phoneType) {
				jQuery(this).attr("checked", "checked");
			} else {
				jQuery(this).removeAttr("checked");
			}
		});

		jQuery("input[name='agency_code']").each(function () {
			if (jQuery(this).val() == agencyCode) {
				jQuery(this).attr("checked", "checked");
			} else {
				jQuery(this).removeAttr("checked");
			}
		});
	}
	jQuery("#search_keyword").val("");

	parameter = {phonetype:phoneType, strtelecomcode:agencyCode,CURITELYN:CURITELYN ,mdl_nm:productName, page_no:1, page_size:5};

	jQuery.post("/cmm/mdl/product_list_condition.sky", parameter, fn_search_callback, "json");
}

function fn_callback_sel() {
	var phoneType, agencyCode, productName, parameter;
	var CURITELYN = "Y";
	if (arguments.length < 3) {
		phoneType = jQuery("input[name='phonetype']:checked").val();
		agencyCode = jQuery("input[name='agency_code']:checked").val();
		productName = jQuery("#mdl_nm option:selected").val();
	} else {
		phoneType = arguments[0];
		agencyCode = arguments[1];
		productName = arguments[2];

		jQuery("input[name='phonetype']").each(function () {
			if (jQuery(this).val() == phoneType) {
				jQuery(this).attr("checked", "checked");
			} else {
				jQuery(this).removeAttr("checked");
			}
		});

		jQuery("input[name='agency_code']").each(function () {
			if (jQuery(this).val() == agencyCode) {
				jQuery(this).attr("checked", "checked");
			} else {
				jQuery(this).removeAttr("checked");
			}
		});
	}

	jQuery("#search_keyword").val("");

	parameter = {phonetype:phoneType, CURITELYN:CURITELYN ,strtelecomcode:agencyCode, mdl_nm:productName, page_no:1, page_size:5};
	jQuery.post("/cmm/mdl/product_list_condition.sky", parameter, fn_search_callback, "json");
}

/**
 * 단말 검색(모델 지정)
 *
 * @param data json result
 */
function fn_search_callback(data) {
	if (data.RESULT_CODE == "SUCCESS") {
		// 검색 결과 개수 출력
		jQuery("#resultCount").text(data.total_article);

		// 이통사
		jQuery("#agencyName").text(jQuery("input[name='agency_code']:checked").parent("label").text());

		// 단말목록
		var html = "";
		var link = "";
		var length = data.deviceList.length;
		var totalPage, pageNo = 0;

		if (length > 0) {
			jQuery("#resultTitle").show();
			jQuery("#defaultTitle").hide();
			jQuery("#defaultDescription").hide();
			// 소프트웨어 다운로드
			for (var i = 0; i < length; i++) {
				var device = data.deviceList[i];
				link = "<a href='#resultArea' onclick='fn_download_list(\"" + device.STRPRDNAME + "\");'><span class='box'></span></a>";

				html += "<li><p class='thumb'>" + link;
				html += "<img src='http://file.ivega.co.kr/upload/product/feature/" + device.STRIMGNAME + "' style='height:90px;' alt='" + device.STRPRDNNAME;
				html += "' /></p><span class='fc6978bc'>" + device.STRPRDNNAME + "</span><br />";
				html += device.STRPRDNAME + "</li>";

				if (i == 0) {
					totalPage = device.total_page;
					pageNo = device.page_no;
				}
			}
		} else {
			jQuery("#defaultTitle").show().ready(function () {
				setTimeout(function () {
					jQuery("#defaultDescription").show();
				}, 100);
			});

			jQuery("#resultTitle").hide();
			jQuery("#descriptionContainer").hide();
			html = "<li class='noneData'>검색된 제품이 없습니다</li>";
		}

		jQuery("#downloadContainer").hide();
		jQuery("#resultContainer").empty().append(jQuery(html)).ready(function () {
			setTimeout(function () {
				jQuery("#pagingContainer").empty().append(jQuery(data.pagingResult));
			}, 10);
		});


		jQuery("#currentPage").text(pageNo);
		jQuery("#totalPage").text(totalPage);

		if (length == 1) {
			jQuery(link).trigger("click");
		}
	}
}

/**
 * 'software 종류 및 설명 자세히 보기' 팝업
 */
function fn_display_description() {
	jQuery.post("./description.sky", "", function (data) {
		var scrollTop = $(window).scrollTop();
		fn_open_bg();
		jQuery("#layerId").append(jQuery(data));
		jQuery("#layerId").show();
		scrollTopPx(scrollTop);
	});
}

/**
 * 단말 다운로드 정보 요청
 * @param strprdname
 */
function fn_download_list(strprdname) {
	if (downloadType == "all") {
		var CURITELYN = "Y";
		jQuery.post("/cmm/mdl/download_list.sky", {strprdname:strprdname, downloadType:downloadType, CURITELYN:CURITELYN}, fn_download_callback, "json");
		
	} else if (downloadType == "manual") {
		jQuery.post("/cmm/mdl/download_list.sky", {strprdname:strprdname, downloadType:downloadType}, fn_download_manual_callback, "json");
	}
}

/**
 * 단말 다운로드 callback
 * @param data
 */
function fn_download_callback(data) {
	if (data.RESULT_CODE == "SUCCESS") {
		jQuery("#downloadContainer").css("display", "block");

		var length = data.downloadList.length;
		var leftHTML = "";
		var rightHTML = "";
		var descriptionHTML = "";
		var leftCount = 7;
		var rightCount = 7;

		for (var i = 0; i < length; i++) {
			var download = data.downloadList[i];
			
			var filter = "셀프";
			if(download.CONVERT_STRSWNAME.indexOf(filter) > 0) continue;
			
			var link = "fn_download(\"" + download.STRFILEURL + "\",";

			link += "\"" + download.STRFILENAME + "\",";
			link += "\"" + download.STRPRDNAME + "\",";
			link += "\"" + download.INTSWSEQ + "\",";
			link += "\"" + download.STRSWVER + "\",";
			link += "\"" + download.STRTYPENAME + "\"); return false;";

			if (i == 0) {
				// 단말 이미지
				jQuery("#downlaodProductImage").empty().append(jQuery("<img src='http://file.ivega.co.kr/upload/product/feature/" + download.STRIMGNAME + "' style='height:150px;' alt='' />"));

				// 단말정보
				var html = "<strong>[" + agencyName(download.STRTELECOMCODE) + "]</strong><span class='fc6978bc'>";

				html += download.STRPRDNNAME + "</span><br /><span>" + download.STRPRDNAME + "</span>";

				jQuery("#downloadProductInfo").empty().append(jQuery(html));
			}

			// 다운로드 항목
			if (i % 2 == 0) {
				// 좌측
				leftHTML += "<li><a href='#' onclick='" + link + "'>" + download.CONVERT_STRSWNAME + "</a></li>";
				leftCount--;
			} else {
				rightHTML += "<li><a href='#' onclick='" + link + "'>" + download.CONVERT_STRSWNAME + "</a></li>";
				rightCount--;
			}

			// 다운로드 항목 설명
			// <li><em class="fc777">전자사전 설치방법 :</em> 전자사전 파일을 다운로드 받아 입축을 풀고, skydict 이름의 폴더를 내장메모리에 복사하여 사용하세요.
			if (download.DESCRIPTION != "") {
				descriptionHTML += "<li><em class='fc777'>" + download.CONVERT_STRSWNAME + " : </em>";
				descriptionHTML += download.DESCRIPTION + "</li>";
			}
		}

		// 공백 처리
		for (var j = leftCount; j > 0; j--) {
			leftHTML += "<li></li>";
		}

		for (var k = rightCount; k > 0; k--) {
			rightHTML += "<li></li>";
		}

		if (descriptionHTML != "") {
			jQuery("#descriptionContainer").css("display", "block");
			jQuery("#descriptionContainer ul").empty().append(jQuery(descriptionHTML));
		}

		jQuery("#downloadLeft").empty().append(jQuery(leftHTML));
		jQuery("#downloadRight").empty().append(jQuery(rightHTML));

		jQuery("#downloadLeft li :even").css("background-color", "#fbfbfb");
		jQuery("#downloadRight li :odd").css("background-color", "#fbfbfb");

		document.location.href = "#resultArea";
        jQuery("#downlaodProductResult").hide();
	} else {
        jQuery("#downloadContainer").css("display", "block");

        // 단말 이미지
        jQuery("#downlaodProductImage").empty().append(jQuery("<img src='http://file.ivega.co.kr/upload/product/feature/" + data.device.STRIMGNAME + "' style='height:150px;' alt='' />"));

        // 단말정보
        var html = "<strong>[" + agencyName(data.device.STRTELECOMCODE) + "]</strong><span class='fc6978bc'>";
        html += data.device.STRPRDNNAME + "</span><br /><span>" + data.device.STRPRDNAME + "</span>";

        jQuery("#downloadProductInfo").empty().append(jQuery(html));

        jQuery("#downloadLeft").empty();
        jQuery("#downloadRight").empty();
        jQuery("#downlaodProductResult").show();

	}
}

/**
 * 사용 설명서
 *
 * @param data json result
 */
function fn_download_manual_callback(data) {
	if (data.RESULT_CODE == "SUCCESS" && data.downloadList.length > 0) {
		var length = data.downloadList.length;
		var html = "";

		jQuery("#manualAgencyName").text("[" + agencyName(data.downloadList[0].STRTELECOMCODE) + "]");
		jQuery("#manualSTRPRDNNAME").text(data.downloadList[0].STRPRDNNAME);
		jQuery("#manualSTRPRDNAME").text(data.downloadList[0].STRPRDNAME);
		jQuery("#manualDeviceImage").attr("src",
		                                  "http://file.ivega.co.kr/upload/product/feature/" + data.downloadList[0].STRIMGNAME);
		jQuery("#manualDeviceImage").height("90px");
		for (var i = 0; i < length; i++) {
			var download = data.downloadList[i];
			html += "<li><a href='#' onclick='fn_download(\"" + download.STRFILEURL + "\", ";
			html += "\"" + download.STRFILENAME + "\", \"" + download.STRPRDNAME + "\", ";
			html += "\"" + download.INTSWSEQ + "\", \"" + download.STRSWVER + "\", ";
			html += "\"" + download.STRTYPENAME + "\"); return false;'>" + download.STRSWNAME + "</a></li>";
		}

		if (i < 3) {
			html += "<li />";
		}

		jQuery("#manualDownload").empty().append(jQuery(html));
		jQuery("#manualDownload li :even").css("background-color", "#fbfbfb");
		jQuery("#downloadContainer").show();
		jQuery("#defaultTip").hide();
		
	} else {
		// 매뉴얼 없음
		jQuery("#manualDownload").empty().append(jQuery("<li class=\"noneData\">해당 모델은 사용설명서를 지원하지 않습니다.</li>"));
		jQuery("#manualSTRPRDNNAME").text(data.device.STRPRDNNAME);
		jQuery("#manualSTRPRDNAME").text(data.device.STRPRDNAME);
		jQuery("#manualDeviceImage").attr("src", "http://file.ivega.co.kr/upload/product/feature/" + data.device.STRIMGNAME);
		jQuery("#manualDeviceImage").height("90px");

		jQuery("#downloadContainer").show();
		jQuery("#defaultTip").hide();
	}

	document.location.href = "#resultArea";
}


/**
 * 단말 검색(검색어)
 */
function fn_search_devices(type, keyword) {
	downloadSearchType = type;
	downloadSearchKeyword = keyword;
	if (jQuery.trim(jQuery("#search_keyword").val()) == "" && type == "search") {
		alert("검색어를 입력하여 주십시오.");

		return;
	}

	var phoneType = "";
	var agencyCode = "";

	if (type == "tag" || type == "full") {
		if (type == "tag") {
			// tag cloud 선택
			jQuery("#search_keyword").val(keyword);
		} else {
			jQuery("#search_keyword").val("");
			jQuery("#mdl_nm option:selected").val("");
		}

		// 단말 종류 및 이통사 선택 취소
		jQuery("input[name='phonetype']").each(function () {
			jQuery(this).removeAttr("checked");
		});

		jQuery("input[name='agency_code']").each(function () {
			jQuery(this).removeAttr("checked");
		});
	} else {
		phoneType = jQuery("input[name='phonetype']:checked").val();
		agencyCode = jQuery("input[name='agency_code']:checked").val();
	}

	var searchKeyword = jQuery("#search_keyword").val();

	var parameter = {phonetype:phoneType, strtelecomcode:agencyCode, search_keyword:searchKeyword, page_no:1, page_size:5};

	jQuery.post("/cmm/mdl/product_list_condition.sky", parameter, fn_search_callback, "json");
}

function fn_search_devices_sel(type, keyword) {
	downloadSearchType = type;
	downloadSearchKeyword = keyword;

	if (jQuery.trim(jQuery("#search_keyword").val()) == "" && type == "search") {
		alert("검색어를 입력하여 주십시오.");

		return;
	}
	var phoneType = "";
	var agencyCode = "";

	if (type == "tag" || type == "full") {
		if (type == "tag") {
			// tag cloud 선택
			jQuery("#search_keyword").val(keyword);
		} else {
			jQuery("#search_keyword").val("");
			jQuery("#mdl_nm option:selected").val("");
		}

		// 단말 종류 및 이통사 선택 취소
		jQuery("input[name='phonetype']").each(function () {
			jQuery(this).removeAttr("checked");
		});

		jQuery("input[name='agency_code']").each(function () {
			jQuery(this).removeAttr("checked");
		});
	} else {
		phoneType = jQuery("input[name='phonetype']:checked").val();
		agencyCode = jQuery("input[name='agency_code']:checked").val();
	}

	var searchKeyword = jQuery("#search_keyword").val();

	var parameter = {phonetype:phoneType, strtelecomcode:agencyCode, search_keyword:searchKeyword, page_no:1, page_size:5};

	jQuery.post("/cmm/mdl/product_list_condition.sky", parameter, fn_search_callback, "json");
}

function fn_page(pageNo) {
	var phoneType = jQuery("input[name='phonetype']:checked").val();
	var agencyCode = jQuery("input[name='agency_code']:checked").val();
	var productName = jQuery("#mdl_nm option:selected").val();
	var searchKeyword = jQuery("#search_keyword").val();
	var parameter = {
		phonetype:phoneType,
		strtelecomcode:agencyCode,
		mdl_nm:productName,
		search_keyword:searchKeyword,
		page_no:pageNo,
		page_size:5
	};

	jQuery.post("/cmm/mdl/product_list_condition.sky", parameter, fn_search_callback, "json");
}
